//****************************************************************************
//	aisa06s.pas
//
//	aISA-A06W/H
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/05/12
//
//  ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
//
//****************************************************************************
unit aisa06s;

interface

uses
  Windows, Messages, SysUtils, Forms, aisa06w;

const
	szTitle = 'Sample';
	szA06 = 'aISA-A06';

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
		procedure ResultMessage(strbuf: String);
		procedure ErrorMessage(wLogSlot: Word);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  strbuf:  String;
	dwDLLVer,  dwVxdVer: DWord;
	bResult:   Boolean;				// 
	wLogSlot:  Word; 					// foCXi[
	dwInitArg: DWord;
	ri:        TAISA06RESOURCE;	// \[X
	i:         Word;
	wDaData:   Word;					// D/A݃f[^
	dwCH1:     DWord;					// CH1̏
	dwCH2:     DWord;					// CH2̏

begin
//---------------------------------------------------------------------------
	// aisa06.dll ̎gp錾
	if Aisa06wDllOpen() = False then
	begin
		ErrorMessage(AISA06_SLOT_AUTO);
		Exit;			// aisa06.dll ̃[hɎs܂
  end;

//---------------------------------------------------------------------------
	// o[Wԍ\
	// aISA-A06W/H DLL,VxD̃o[Wԍ擾
	if Aisa06wGetVersion(dwDLLVer, dwVxdVer) = False then
	begin
		ErrorMessage(AISA06_SLOT_AUTO);
		Exit;
	end;

	strbuf := Format('GetVersion'#10 +
					 'DLL Version: %08xH'#10 +
					 'Vxd Version: %08xH',
                     [dwDLLVer, dwVxdVer]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// aISA-A06W/H̎gp錾
	wLogSlot := AISA06_SLOT_AUTO;			// gp̃foCXT܂B
	dwInitArg := 0;
	bResult := Aisa06wCreate(wLogSlot,// ꍇA̎̃foCXi[܂B
							 						0,				// ̈ 0 Zbg܂B
							 						0,
							 						dwInitArg);

	if bResult = False then		// foCX܂B
	begin
		ErrorMessage(AISA06_SLOT_AUTO);
		Exit;
	end;

	strbuf := Format('aISA-A06W/H Created'#10#10 +
                   'LogSlot: %2d', [wLogSlot]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// \[X擾
	if Aisa06wGetResource(wLogSlot, @ri) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('Board Name: %s'#10 +
    				 			 'NumPorts: %2d'#10 +
    				 			 'IO Address: %04xH-%04xH',
                     [szA06, ri.dwIOPortLength[1],
                      ri.dwIOPortBase[1],
	                    ri.dwIOPortBase[1] + ri.dwIOPortLength[1] - 1]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// o̓f[^̐ݒ
	wDaData := $0FFF;

	// gp{[h aISA-A06H ̏ꍇAŌ 2`lւ̏o͖͂܂B
	for i := 0 to AISA06_MAX_CH_W - 1 do
		if Aisa06wSetData(wLogSlot, i, wDaData) = False then
		begin
			ErrorMessage(wLogSlot);
			Exit;
		end;

	ResultMessage('o̓f[^ݒ肵܂B');

//---------------------------------------------------------------------------
	// O͏Ԃ̎擾
	if Aisa06wGetCH(wLogSlot, dwCH1, dwCH2) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('O͏Ԃ̎擾'#10 +
									 'CH1̏=%xH'#10 +
									 'CH2̏=%xH',
									 [dwCH1, dwCH2]);

	ResultMessage(strbuf);


//---------------------------------------------------------------------------
	// aISA-A06W/H̎gpJ
	if Aisa06wClose(wLogSlot) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('aISA-A06W/H Closed');

	// aisa06.dll ̎gpJ
	if Aisa06wDllClose() = False then
	begin
		Application.MessageBox(PChar('DLL ̃A[hɎs܂B'), szTitle, MB_OK + MB_ICONSTOP);
		Exit;			// aisa06.dll ̃A[hɎs܂B
  end;

end;

// ʂ\
procedure TForm1.ResultMessage(strbuf: String);
begin
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;

// G[bZ[W\
procedure TForm1.ErrorMessage(wLogSlot: Word);
var
	dwRes: DWord;
	strbuf: String;
begin
	dwRes := Aisa06wGetLastError(wLogSlot);

	case dwRes of
		AISA06_ERR_WRAPDLL:
    	strbuf := 'DLL Load error';
  else
		strbuf := Format('aISA-A06W/H error'#10#10'Error code: %08xH',[dwRes]);
  end;

	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.
